poj 1787 记录路径的多重背包

2024-04-28 17:32

本文主要是介绍poj 1787 记录路径的多重背包,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

 

 

 

如题:http://poj.org/problem?id=1787

 

Description

Charlie is a driver of Advanced Cargo Movement, Ltd. Charlie drives a lot and so he often buys coffee at coffee vending machines at motorests. Charlie hates change. That is basically the setup of your next task.

Your program will be given numbers and types of coins Charlie has and the coffee price. The coffee vending machines accept coins of values 1, 5, 10, and 25 cents. The program should output which coins Charlie has to use paying the coffee so that he uses as many coins as possible. Because Charlie really does not want any change back he wants to pay the price exactly.

Input

Each line of the input contains five integer numbers separated by a single space describing one situation to solve. The first integer on the line P, 1 <= P <= 10 000, is the coffee price in cents. Next four integers, C1, C2, C3, C4, 0 <= Ci <= 10 000, are the numbers of cents, nickels (5 cents), dimes (10 cents), and quarters (25 cents) in Charlie's valet. The last line of the input contains five zeros and no output should be generated for it.

Output

For each situation, your program should output one line containing the string "Throw in T1 cents, T2 nickels, T3 dimes, and T4 quarters.", where T1, T2, T3, T4 are the numbers of coins of appropriate values Charlie should use to pay the coffee while using as many coins as possible. In the case Charlie does not possess enough change to pay the price of the coffee exactly, your program should output "Charlie cannot buy coffee.".

Sample Input

12 5 3 1 2
16 0 0 0 1
0 0 0 0 0

Sample Output

Throw in 2 cents, 2 nickels, 0 dimes, and 0 quarters.
Charlie cannot buy coffee.

 

 

题目给出总钱数,要求用1,5,10,25价值的硬币拼出总钱数,并要求硬币尽量用的多。

 

一开始没注意到硬币的要求,将硬币价值作为价值w进行背包,wa了好久

关于记录路径,只要在背包的同时,记录这一层是由那一层过来的就行,并同时记录上一层要多少个硬币才能变为这一层,至于哪一种,就可以用int t=(n-path[n])/count[n];推出。

还有要注意的是背包策略,f[j]并不是在一定金额中尽量多放硬币,f[j]代表的是满足拼成j金额能放硬币的最多数量f[j]=max(f[j-k*c]+k) ,初始化f数组为-inf。

#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;

int num[5];
int n;
int w[5]={0,1,5,10,25};
int f[10005];
int path[10005];
int count[10005];


void ZeroOnePack(int k,int c)
{
 int j;
 for(j=n;j>=k*c;j--)
 {
  if(f[j-k*c]+k>f[j])
  {
   f[j]=f[j-k*c]+k;
   path[j]=j-k*c;
   count[j]=k;
  }
 }
}
void CompletePack(int c)
{
 int j;
 for(j=c;j<=n;j++)
 {
  int tv=f[j];
  if(f[j-c]+1>f[j])
  {
   f[j]=f[j-c]+1;
   path[j]=j-c;
   count[j]=1;
  }
  
  
 }
}

void MultiplePack(int c,int cnt)
{
 if(c*cnt>=n)
 {
  CompletePack(c);
  return;
 }
 int k=1;
 while(k<cnt)
 {
  ZeroOnePack(k,c);
  cnt-=k;
  k*=2;
 }
  ZeroOnePack(cnt,c);
}

int main()
{
 //freopen("C:\\1.txt","r",stdin);
 //freopen("C:\\3.txt","w",stdout);
 while(~scanf("%d%d%d%d%d",&n,&num[1],&num[2],&num[3],&num[4])
  &&(n||num[1]||num[2]||num[3]||num[4]))
 {
 // printf("%d %d %d %d %d\n",n,num[1],num[2],num[3],num[4]);
  memset(f,0,sizeof(f));
  memset(path,0,sizeof(path));
  memset(count,0,sizeof(count));
  int i;
  for(i=1;i<=n;i++)
   f[i]=-10005;
  for(i=1;i<=4;i++)
   MultiplePack(w[i],num[i]);
  if(f[n]<=0)
   printf("Charlie cannot buy coffee.\n");
  else
  {
   int c1=0,c2=0,c3=0,c4=0;
   while(n)
   {
    int t=(n-path[n])/count[n];
    if(t==1)
     c1+=count[n];
    else if(t==5)
     c2+=count[n];
    else if(t==10)
     c3+=count[n];
    else
     c4+=count[n];
    n=path[n];
   }
   printf("Throw in %d cents, %d nickels, %d dimes, and %d quarters.\n",c1,c2,c3,c4);
  }
 }
 return 0;
}

 

这篇关于poj 1787 记录路径的多重背包的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/943832

相关文章

poj2576(二维背包)

题意:n个人分成两组,两组人数只差小于1 , 并且体重只差最小 对于人数要求恰好装满,对于体重要求尽量多,一开始没做出来,看了下解题,按照自己的感觉写,然后a了 状态转移方程:dp[i][j] = max(dp[i][j],dp[i-1][j-c[k]]+c[k]);其中i表示人数,j表示背包容量,k表示输入的体重的 代码如下: #include<iostream>#include<

hdu2159(二维背包)

这是我的第一道二维背包题,没想到自己一下子就A了,但是代码写的比较乱,下面的代码是我有重新修改的 状态转移:dp[i][j] = max(dp[i][j], dp[i-1][j-c[z]]+v[z]); 其中dp[i][j]表示,打了i个怪物,消耗j的耐力值,所得到的最大经验值 代码如下: #include<iostream>#include<algorithm>#include<

csu(背包的变形题)

题目链接 这是一道背包的变形题目。好题呀 题意:给n个怪物,m个人,每个人的魔法消耗和魔法伤害不同,求打死所有怪物所需的魔法 #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>//#include<u>#include<map

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu1171(母函数或多重背包)

题意:把物品分成两份,使得价值最接近 可以用背包,或者是母函数来解,母函数(1 + x^v+x^2v+.....+x^num*v)(1 + x^v+x^2v+.....+x^num*v)(1 + x^v+x^2v+.....+x^num*v) 其中指数为价值,每一项的数目为(该物品数+1)个 代码如下: #include<iostream>#include<algorithm>

hdu2544(单源最短路径)

模板题: //题意:求1到n的最短路径,模板题#include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdlib.h>#include<ctype.h>#i

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int